local uc = select(2, UnitClass("player"))
if (uc ~= "HUNTER") and (uc ~= "ROGUE") then return end


MDH = LibStub("AceAddon-3.0"):NewAddon("MDH", "AceEvent-3.0")
local L = LibStub("AceLocale-3.0"):GetLocale("MisDirectionHelper",true)
local QTC = LibStub("LibQTip-1.0")
local icon = LibStub("LibDBIcon-1.0")
local _G = _G
local MDHText = "MDH"
local channels = {["RAID"] = _G.RAID, ["PARTY"] = _G.PARTY, ["WHISPER"] = _G.WHISPER}
local misdtarget, tooltip
local imd = GetSpellInfo(34477)
local iff = GetSpellInfo(82692)
local itt = GetSpellInfo(57934)
local iua = GetSpellInfo(51672)
local hiconinfo = {
	[imd] = {"Interface\\Icons\\Ability_Hunter_Misdirection", 151},
	[iff] = {"Interface\\Icons\\Ability_Hunter_FocusFire", 134},
}
local hicons = {[151] = imd, [134] = iff}
local riconinfo = {
	[itt] = {"Interface\\Icons\\Ability_Rogue_TricksOftheTrade", 454},
	[iua] = {"Interface\\Icons\\Ability_Rogue_UnfairAdvantage", 457},
}
local ricons = {[454] = itt, [457] = iua}

local function set(info, value)

	local key = info[#info]
	MDH.db.profile[key] = value

end

local function get(info)

	local key = info[#info]
	return MDH.db.profile[key]

end

local defaults = {
	profile = {
		minimap = {hide = false},
		cChannel = "PARTY",
		Name = "Pet",
		Petname = _G.UNKNOWN,
		bAnnounce = false,
		hicon = 151,
		ricon = 454,
		hname = "MDH " .. imd,
		rname = "MDH " .. itt,
		target = "pet",
	},	
}

--Create the data broker
function MDH:CreateLDBObject()

	MDH.dataObject = LibStub:GetLibrary("LibDataBroker-1.1"):NewDataObject("MisdirectionHelper", {
		type = "data source",
		text = MDH:TTText(),
		icon = "Interface\\Icons\\Ability_Hunter_Misdirection",
		OnClick = 
			function(frame, button)
				if button == "RightButton" then
					InterfaceOptionsFrame_OpenToCategory(MDH.optionsFrame)
				elseif button == "LeftButton" then
					MDH:PlyrTarg()
				end
			end,
		OnEnter = 
			function(frame)
				tooltip = QTC:Acquire("Broker_MisdirectionHelperTooltip", 1, "CENTER")
				tooltip:SmartAnchorTo(frame)
				tooltip:SetAutoHideDelay(0.25, frame)
				MDH:MDHShowToolTip()
			end,
		OnLeave = nil,
	})
	
end

local function HandlerFunc(arg)

    if arg == "b1" then

		MDH:PrtyTank()

    elseif arg == "b2" then
	
		MDH:MDHtarget()

    elseif arg == "b3" then

		MDH:ToT()

	elseif arg == "b4" then

		MDH:PlyrPet()

	elseif arg == "b5" then

		MDH:PopUp()

	elseif arg == "f" then
	
		MDH:MDHfocus()
		
	elseif arg == "b6" then

		InterfaceOptionsFrame_OpenToCategory(MDH.optionsFrame)

    end

end

function MDH:MDHShowToolTip()

	if InCombatLockdown() then return end

	local headerFont, y
	
	if not tooltip.lines then return end

	tooltip:Clear()
	
	headerFont = CreateFont("MisdirectionHelperHeaderFont")
	MisdirectionHelperHeaderFont:CopyFontObject(GameTooltipHeaderText)
	MisdirectionHelperHeaderFont:SetFont(MisdirectionHelperHeaderFont:GetFont(), 15)
	
    y = tooltip:AddLine()
	tooltip:SetCell(y, 1, "|cffffff00MisdirectionHelper|r",MisdirectionHelperHeaderFont, "CENTER", 1)
    tooltip:SetLineColor(y, 1, 0, 1, 1)
	
    y = tooltip:AddLine()
	tooltip:SetCell(y, 1, "", "CENTER", 1)
	tooltip:SetLineColor(y, 0, 0, 1, 1)
	
	y = tooltip:AddLine()
	tooltip:SetCell(y, 1, "", "CENTER", 1)
    tooltip:SetLineColor(y, 0, 0, 1, 1)

    y = tooltip:AddLine()
	tooltip:SetCell(y, 1, " " .. L["Set To Party Tank"])
	tooltip:SetCellScript(y, 1, "OnMouseDown", function() HandlerFunc("b1") end)
    tooltip:SetLineColor(y, 1, 0, 0, 1)
	
    y = tooltip:AddLine()
    tooltip:SetCell(y, 1, " " .. L["Set To Target"])
	tooltip:SetCellScript(y, 1, "OnMouseDown", function() HandlerFunc("b2") end)
    tooltip:SetLineColor(y, 1, 0, 0, 1)
	
    y = tooltip:AddLine()
    tooltip:SetCell(y, 1, " " .. L["Set to Target Of Target"])
	tooltip:SetCellScript(y, 1, "OnMouseDown", function() HandlerFunc("b3") end)
    tooltip:SetLineColor(y, 1, 0, 0, 1)

	y = tooltip:AddLine()
	tooltip:SetCell(y, 1, " " .. L["Set to Focus"])
	tooltip:SetCellScript(y, 1, "OnMouseDown", function() HandlerFunc("f") end)
	tooltip:SetLineColor(y, 1, 0, 0, 1)
	
    y = tooltip:AddLine()
	tooltip:SetCell(y, 1, "", "CENTER", 1)
	tooltip:SetLineColor(y, 0, 0, 1, 1)
	
	if uc == "HUNTER" then
	
		y = tooltip:AddLine()
		tooltip:SetCell(y, 1, " " .. L["Set to Your Pet"])
		tooltip:SetCellScript(y, 1, "OnMouseDown", function() HandlerFunc("b4") end)
		tooltip:SetLineColor(y, 0, 1, 1, 1)
		
	end

    y = tooltip:AddLine()
    tooltip:SetCell(y, 1, " " .. L["Enter Player Name"])
	tooltip:SetCellScript(y, 1, "OnMouseDown", function() HandlerFunc("b5") end)
	tooltip:SetLineColor(y, 0, 1, 1, 1)
	
	y = tooltip:AddLine()
	tooltip:SetCell(y, 1, "", "CENTER", 1)
	tooltip:SetLineColor(y, 0, 0, 1, 1)
	
	y = tooltip:AddLine()
	tooltip:SetCell(y, 1, "", "CENTER", 1)
	tooltip:SetLineColor(y, 0, 0, 1, 1)
	
	y = tooltip:AddLine()
    tooltip:SetCell(y, 1, _G.OPTIONS, "b6")
    tooltip:SetLineColor(y, 0, 1, 0, 1)
	
    y = tooltip:AddLine()
	tooltip:SetCell(y, 1, "", "CENTER", 1)
	tooltip:SetLineColor(y, 0, 0, 1, 1)
	 
	y = tooltip:AddLine()
	tooltip:SetCell(y, 1, "", "CENTER", 1)
	tooltip:SetLineColor(y, 0, 0, 1, 1)
	
	y = tooltip:AddLine()
	tooltip:SetCell(y, 1, "|cffffff00" .. string.format(L["MDH is set to: %s"], "|cffff0033 " .. self:TTText()), "CENTER", 1)
	tooltip:SetLineColor(y, 1, 0, 1, 0)
	
    y = tooltip:AddLine()
	tooltip:SetCell(y, 1, "", "CENTER", 1)
	tooltip:SetLineColor(y, 0, 0, 1, 1)
	
	y = tooltip:AddLine()
	tooltip:SetCell(y, 1, "", "CENTER", 1)
	tooltip:SetLineColor(y, 0, 0, 1, 1)
	
	y = tooltip:AddLine()
	tooltip:SetCell(y, 1, "|cffffff00" .. L["Left Click Each Text To Activate"] .. "|r ", "CENTER", 1)
	tooltip:SetLineColor(y, 1, 0, 1, 1)
	
	y = tooltip:AddLine()
	tooltip:SetCell(y, 1, "|cffffff00" .. L["Right Click For MDH Options"] .. "|r", "CENTER", 1)
    tooltip:SetLineColor(y, 1, 0, 1, 1)
	
    tooltip:Show()

end

function MDH:MDHTextUpdate()

	MDH.dataObject.text = self:TTText()

end

function MDH:validateTarget(unit)

	local t = UnitName(unit)
	local mdt = unit

	if t then
	
		if UnitIsUnit(unit, "pet") or UnitInParty(unit) or UnitInRaid(unit) then
		
			mdt = t
			
		end
		
	end
	
	return mdt
	
end

function MDH:ToT()
	
	self.db.profile.target = "targettarget"
	self.db.profile.name = self:validateTarget("targettarget")
	self:MDHEditMacro()
	self:MDHShowToolTip()
	
end

function MDH:PlyrPet()

	if UnitExists("pet") then
	
		self:MDHgetpet()

	end
	
	self.db.profile.target = "pet"
	self.db.profile.name = self.db.profile.Petname
	self:MDHEditMacro()
	self:MDHShowToolTip()
	
end

function MDH:PrtyTank()

	self:MDHtank()
	self:MDHEditMacro()
	self:MDHShowToolTip()
	
end

function MDH:PopUp()

	StaticPopup_Show("MDH_GET_PLAYER_NAME")

end

function MDH:MDHLoad()

	if UnitExists("pet") then

		self:MDHgetpet()
		
	end

	self:MDHTextUpdate()
	self:MDHEditMacro()

end

function MDH:MDHgetpet()

	local petname = UnitName("pet")

	if petname == _G.UNKNOWN then
	
		petname = self.db.profile.Petname
		
	end

	self.db.profile.Petname = petname

end

function MDH:MDHfocus()

	self.db.profile.target = "focus"
	self.db.profile.name = self:validateTarget("focus")
	self:MDHEditMacro()
	self:MDHShowToolTip()
	
end

function MDH:MDHtarget()
	
	self.db.profile.target = self:validateTarget("target")
	self.db.profile.name = self:validateTarget("target")
	self:MDHEditMacro()
	self:MDHShowToolTip()

end

--[[
not working properly yet :-/
function MDH:MDHtank()

	local NumParty = GetNumPartyMembers()
	local NumRaid = GetNumRaidMembers()
	local NumPlayers, player, istank, pre
	local mdtank = self.db.profile.target
	
	if NumRaid == 0 then
	
		NumPlayers = NumParty
		pre = "party"
		
	else
	
		NumPlayers = NumRaid
		pre = "raid"
		
	end
	
	if NumPlayers > 0 then
	
		for player = 1, NumPlayers do
		
			istank = GetPartyAssignment("MAINTANK", pre .. player)
		
			if istank then
			
				mdtank = UnitName(pre .. player)
				break
				
			end
			
		end
		
	end
	
	self.db.profile.target = mdtank
	self.db.profile.name = mdtank
			
end
--]]

function MDH:MDHtank()

	local NumParty=GetNumPartyMembers()
	local NumRaid=GetNumRaidMembers()
	local mdhealth = 0
	local mdtank = self.db.profile.Name
	local i, class

	if (0 < NumParty) and (NumRaid == 0) then

		for i = 1, NumParty do
		
			_, class = UnitClass("party" .. i)
			
			if ("WARRIOR" == class) or ("DRUID" == class) or ("DEATHKNIGHT" == class) or ("PALADIN" == class) then

				if mdhealth < UnitHealth("party" .. i) then
				
					mdhealth = UnitHealth("party" .. i)
					mdtank = UnitName("party" .. i)

				end
				
			end	
			
		end
		
	elseif 0 < NumRaid then
	
		for i = 1, NumRaid do
		
			_, class=UnitClass("raid" .. i)
			
			if ("WARRIOR" == class) or ("DRUID" == class) or ("DEATHKNIGHT" == class) or ("PALADIN" == class) then
			
				if mdhealth < UnitHealth("raid" .. i) then
				
					mdhealth = UnitHealth("raid" .. i)
					mdtank = UnitName("raid" .. i)
					
				end
				
			end	
			
		end
		
	end
	
	self.db.profile.Name = mdtank

end

function MDH:MDHEditMacro()

	local macro, macroid
	local spell = imd
	local id = MDH.db.profile.hicon or hiconinfo[imd][2]
	local mname = MDH.db.profile.hname

	if uc == "ROGUE" then
	
		spell = itt
		id = MDH.db.profile.ricon or riconinfo[itt][2]
		mname = MDH.db.profile.rname

	end
	
	self:MDHTextUpdate()
	macro = string.format("#showtooltip\n/cast [mod:shift,@none][@%s,nodead,exists] %s; %s", self.db.profile.target, spell, spell)

	macroid = GetMacroIndexByName(mname)

	if macroid == 0 then
	
		CreateMacro(mname , id, macro, 1, 1)

	else

		EditMacro(macroid, mname , id, macro)

	end

end

function MDH:MDHChat()

	local msg = string.format((uc == "HUNTER") and L["%s Misdirects to %s"] or L["%s casts Tricks of the Trade on %s"], UnitName("player"), misdtarget)
	local s = false
	
	if IsAddOnLoaded("CastYeller2") or IsAddOnLoaded("CastYeller") then return end

	if (self.db.profile.cChannel == "PARTY") and (GetNumPartyMembers() ~= 0) then
	
		s = true

	elseif (self.db.profile.cChannel == "RAID") and (GetNumRaidMembers() ~= 0) then

		s = true
		
	elseif (MDH.db.profile.cChannel == "WHISPER") then
	
		s = true

	end
	
	if s then SendChatMessage(msg, self.db.profile.cChannel, nil, misdtarget) end

end

--First visible options frame
local function createMainPanel()

	local frame = CreateFrame("Frame", "MisdirectionHelperMain")
	local title = frame:CreateFontString(nil, "ARTWORK", "GameFontNormalLarge")
	local version = frame:CreateFontString(nil, "ARTWORK", "GameFontNormalLarge")
	local author = frame:CreateFontString(nil, "ARTWORK", "GameFontNormalLarge")

	title:SetFormattedText("|T%s:%d|t %s", "Interface\\ICONS\\Ability_Hunter_Misdirection", 32, "Misdirection Helper 2")
	title:SetPoint("CENTER", frame, "CENTER", 0, 170)

	version:SetText(_G.GAME_VERSION_LABEL .. " " .. GetAddOnMetadata("MisdirectionHelper2", "Version"))
	version:SetPoint("CENTER", frame, "CENTER", 0, 130)

	author:SetText(L["Author"] .. ": Deepac")
	author:SetPoint("CENTER", frame, "CENTER", 0, 100)

	return frame

end

function MDH:OnInitialize()
	
	local AceConfig = LibStub("AceConfig-3.0")
	local AceConfigDialog = LibStub("AceConfigDialog-3.0")
	local AceDBOptions = LibStub("AceDBOptions-3.0")
	local mainPanel = createMainPanel()
	local optionsTable

	self.db = LibStub("AceDB-3.0"):New("MisdirectionHelperDB", defaults)
	optionsTable = {
		handler = MDH,
		type = "group",
		name = _G.MAIN_MENU,
		inline = false,
		args = {
			basicDesc = {
				order = 1,
				type = "description",
				name = _G.MAIN_MENU,
			},
			showMinimapIcon = {
				order = 2,
				type = "toggle",
				name = L["Minimap Icon"],
				desc = L["Toggle Minimap icon"],
				get = function(info) return not MDH.db.profile.minimap.hide end,
				set = function(info, value)
					MDH.db.profile.minimap.hide = not value
					if value then
						icon:Show("MisdirectionHelper")
					else
						icon:Hide("MisdirectionHelper")
					end
				end,
			},
			buffmessage = {
				order = 3,
				type = "toggle",
				name = L["Buff Alert"],
				desc = L["Toggle Misdirection Applied Announcment"],
				get = function(info) return MDH.db.profile.bAnnounce end,
				set = function(info, value)
					MDH.db.profile.bAnnounce = value
				end,
			},
			cChannel = {
				type = "select",
				name = L["Buff Channel"],
				desc = L["Select Channel for Buff Announcements"],
				order = 4,
				get = function(info) return MDH.db.profile.cChannel end,
				set = function(info, value)
					MDH.db.profile.cChannel = value
				end,
				values = channels,
			},
			spacer1 = {
				order = 5,
				type = "description",
				name = "\n",
			},			
			hicon = {
				type = "select",
				name = L["Misdirection macro icon"],
				order = 6,
				icon = "Interface\\Icons\\Ability_Hunter_Misdirection",
				hidden = function() return uc == "ROGUE" end,
				get = function(info) return MDH.db.profile.hicon or hiconinfo[imd][2] end,
				set = function(info, value)
					MDH.db.profile.hicon = value
					MDH:MDHEditMacro()
				end,
				values = hicons,
			},
			ricon = {
				type = "select",
				name = L["Tricks of the Trade macro icon"],
				order = 7,
				hidden = function() return uc == "HUNTER" end,
				get = function(info) return MDH.db.profile.ricon or riconinfo[itt][2] end,
				set = function(info, value)
					MDH.db.profile.ricon = value
					MDH:MDHEditMacro()
				end,
				values = ricons,
			},
			hmname = {
				type = "input",
				name = L["Macro name"],
				width = "full",
				desc = L["Name to use for the macro"],
				get = function(info) return MDH.db.profile.hname end,
				set = function(info, value)
					MDH.db.profile.hname = value
					MDH:MDHEditMacro()
				end,
				hidden = function() return uc == "ROGUE" end,
			},
			rmname = {
				type = "input",
				name = L["Macro name"],
				desc = L["Name to use for the macro"],
				get = function(info) return MDH.db.profile.rname end,
				set = function(info, value)
					MDH.db.profile.rname = value
					MDH:MDHEditMacro()
				end,
				hidden = function() return uc == "HUNTER" end,
			},
		},
	}

	mainPanel.name = "Misdirection Helper 2"
	InterfaceOptions_AddCategory(mainPanel)
	AceConfig:RegisterOptionsTable("MisdirectionHelperOptions", optionsTable)
	AceConfig:RegisterOptionsTable("MisdirectionHelperProfiles", AceDBOptions:GetOptionsTable(self.db))
	MDH.optionsFrame = AceConfigDialog:AddToBlizOptions("MisdirectionHelperOptions", _G.MAIN_MENU, "Misdirection Helper 2")
	AceConfigDialog:AddToBlizOptions("MisdirectionHelperProfiles", L["Profiles"], "Misdirection Helper 2")
	
	self:CreateLDBObject()

	if icon then

		icon:Register("MisdirectionHelper", MDH.dataObject, MisdirectionHelperDB)

	end
	
	self:MDHOnload()

end

function MDH:MDHOnload()

	self:RegisterEvent("PLAYER_ENTERING_WORLD")
	self:RegisterEvent("UNIT_PET")
	self:RegisterEvent("UNIT_SPELLCAST_SENT")
	self:RegisterEvent("UNIT_SPELLCAST_SUCCEEDED")
	self:RegisterEvent("PLAYER_REGEN_DISABLED")
	self:RegisterEvent("PLAYER_TARGET_CHANGED")
	self:RegisterEvent("PLAYER_FOCUS_CHANGED")

end

function MDH:PLAYER_TARGET_CHANGED()

	if not InCombatLockdown() then
	
		if self.db.profile.target == "target" then
		
			self.db.profile.name = self:validateTarget("target")
			self:MDHTextUpdate()
			
		end
	
	end
	
end

function MDH:PLAYER_FOCUS_CHANGED()

	if not InCombatLockdown() then
	
		if self.db.profile.target == "focus" then
			
			self.db.profile.name = self:validateTarget("focus")
			self:MDHTextUpdate()
			
		end
	
	end
	
end

function MDH:PLAYER_ENTERING_WORLD()

	self:MDHLoad()

end

function MDH:UNIT_PET(unitid)

	if unitid == "player" and UnitExists("pet") then
  
		self:MDHgetpet()

	end

end

function MDH:UNIT_SPELLCAST_SENT(unitid, spell, rank, target)

	if (unitid == "player") and (spell == GetSpellInfo(34477)) then
	
		misdtarget = target

	end

end

function MDH:UNIT_SPELLCAST_SUCCEEDED(unitid, spell, rank, uk, spellid)

	if (unitid == "player") and (spell == GetSpellInfo(34477)) then
	
		if self.db.profile.bAnnounce then

			self:MDHChat()

		end
		
	end
	
end

function MDH:PLAYER_REGEN_DISABLED()

	--unit entered combat
	if tooltip then tooltip:Hide() end
	
end

function MDH:TTText()

	local n = self.db.profile.name or ""
	
	if n == "target" then
		
		uname = _G.TARGET
			
	elseif n == "targettarget" then
		
		uname = _G.SHOW_TARGET_OF_TARGET_TEXT
			
	elseif n == "focus" then
		
		uname = _G.BINDING_NAME_FOCUSTARGET
			
	elseif n == "pet" then
		
		uname = _G.PET
			
	elseif n == "" then
		
		uname = L["Nobody"]
	
	else
	
		uname = n

	end
	
	return uname
	
end

local function onAccept(this)

	if not UnitAffectingCombat("player") then

		MDH.db.profile.target = string.lower(this.editBox:GetText() or "")
		MDH.db.profile.name = MDH.db.profile.target
		
		if MDH.db.profile.target == "pet" then
		
			MDH.db.profile.name = MDH.db.profile.Petname
			
		elseif MDH.db.profile.target == "tank" then
		
			MDH:MHDtank()
			
		elseif (MDH.db.profile.target == "target") or (MDH.db.profile.target == "t") then
		
			MDH:MHDtarget()

		end
		
		MDH:MDHEditMacro()
		
	end

	MDH:MDHShowToolTip()
	
	this:Hide()
	
end

StaticPopupDialogs["MDH_GET_PLAYER_NAME"] = {
	text = (uc == "HUNTER") and L["Player to Misdirect to"] or L["Player to cast Tricks of the Trade on"],
	button1 = _G.ACCEPT,
	button2 = _G.CANCEL,
	hasEditBox = 1,
	OnAccept = onAccept,
	EditBoxOnEnterPressed = function(this) onAccept(this:GetParent()) end,
	EditBoxOnEscapePressed = function(this) this:GetParent():Hide()	end,
	timeout = 0,
	whileDead = 1,
	hideOnEscape = 1
}